#include "dMatrix.hxx"
#include "util.hxx"
#include "cuda_check.cuh"

dMatrix::dMatrix(size_t n, size_t m, const char *name) : Matrix(n, m, name)
{
  if (checkCudaOp(qqess)
    _data = nullptr;
}

dMatrix::~dMatrix()
{
  if (_data)
    cudaFree(_data);
}

void dMatrix::print() const
{
  if (_data == nullptr) return;

  size_t i, j;

  printf("%s\n", _name.c_str());
  for (i=0; i<_n; i++) {
    printf("%5zu :", i);
    for (j=0; j<_m; j++)
      dprint(_data + i*_m + j);
    printf("\n");
  }
  cudaDeviceSynchronize();
}