
#include "dVector.hxx"
#include "cuda_check.cuh"
#include "util.hxx"

dVector::dVector(size_t n, const char *name) : Vector(n, name)
{
  if (checkCudaOp(cudaMalloc((void **) &_data, _bytes)) != cudaSuccess)
    _data = nullptr;
}

dVector::~dVector()
{
  if (_data)
    cudaFree(_data);
}

void dVector::print() const
{
  if (_data == nullptr) return;

  size_t i;

  printf("%s\n", _name.c_str());
  for (i=0; i<_n; i++) {
    printf("%5zu :", i);
    dprint(_data + i);
  }
  cudaDeviceSynchronize();
  printf("\n");
}